/** Rekursion.java
 *
 *  Eine Klasse zur Demonstration von rekursiven Algorithmen.
 */


class Rekursion {

  // Fakultaet
  static long fac(int n) {
	if (n == 0) return 1L;
	return fac(n-1)*n;
  }

  // Quadrat
  static long sq(int n) {
	if (n == 0) return 0L;
	return sq(n-1) + 2*n - 1;
  }

  // Summe der ersten n natuerlichen Zahlen
  static long rSum(int n) {
	if (n == 0) return 0L;
	return rSum(n-1) + n;
  }

  // Fibonacci-Folge
  static long fib(int n) {
	if (n <= 1) return 1L;
	return fib(n-2) + fib(n-1);
  }


  public static void main (String[] args) {
	int n = Integer.parseInt(args[0]);
	System.out.println(n + "! = " + fac(n));
	System.out.println(n + "^2 = " + sq(n));
	System.out.println("Summe der ersten " + n + " Zahlen: " + rSum(n));
	System.out.println(n+1 + ". Fibonacci-Zahl: " + fib(n));
  }
}

// Rekursion	
