/** Sort.java.merge (mit Mergesort)
 *  
 *  Ein Algorithmus, der einige Sortieralgorithmen implementiert.
 */


public class Sort {

  private static int[] folge;


  // Ausgabe einer Folge
  public static void show(int[] folge) {
    for(int i=0;i<folge.length-1;i++)
      System.out.print(folge[i] + ",");
      System.out.println(folge[folge.length-1]);
  }


  // Austausch zweier Folgenelemente
  private static void tausch(int i, int j) {
    int z = folge[i];
    folge[i] = folge[j];
    folge[j] = z;
  }

  
  // Selectionsort
  public static void selectionSort(int[] toBeSorted) {

    folge = toBeSorted; 
    int i,j,m;

    for(i=0;i<folge.length-1;i++) {
      m=i;
      for(j=i+1;j<folge.length;j++) 
        if (folge[j] < folge[m]) m=j;
      tausch(i,m);
    }
  }


  // Bubblesort
  public static void bubbleSort(int[] toBeSorted) {

    folge = toBeSorted; 
    int i,j;

    for(i=folge.length-1;i>0;i--) 
      for(j=0;j<i;j++)
        if (folge[j]>folge[j+1]) tausch(j,j+1);
  }


  // Mergesort
  public static void mergeSort(int[] toBeSorted) {
    folge = toBeSorted;
    mergeSort(0,folge.length-1);
  }


  private static void mergeSort(int l, int r) {
    int m;

    if (l >= r) return;         // Abbruchbedingung

    m = (l+r)/2;                // Teilen
    mergeSort(l,m);             // Herrschen: linker Teil
    mergeSort(m+1,r);           // Herrschen: rechter Teil

    merge(l,r);
  }


  // Hilfsmethode zum Zusammensortieren  
  private static void merge(int l, int r) {

    int i,j,k,m;

    m = (l + r) / 2;

    int[] b = new int[r-l+1];   // tempor"ares Array

    k = 0;
    
    // untere H"alfte von folge in b kopieren
    for(i=l; i<=m; i++)
        b[k++] = folge[i];

    // obere H"alfte von folge in umgekehrte Reihenfolge 
    // in b kopieren
    for(j=r; j>m; j--)
        b[k++] = folge[j];

    i = 0; j = (r-l); k = l;

    // jeweils das n"achstgr"osste Element von aussen 
    // zur"uckkopieren bis Mitte erreicht ist
    while (i <= j)
        if (b[i] <= b[j])
          folge[k++] = b[i++];
        else 
          folge[k++] = b[j--];
  }
}

// Sort (.merge)
